;;;;
;;;; pregexp-extra -- Additions to the regular expression library.
;;;;
;;;; Copyright 2006 Dean Ferreyra, All rights reserved
;;;;
;;;; This file is part of octw-guile-general.
;;;;
;;;; octw-guile-general is free software: you can redistribute it and/or modify
;;;; it under the terms of the GNU General Public License as published by
;;;; the Free Software Foundation, either version 3 of the License, or
;;;; (at your option) any later version.
;;;; 
;;;; octw-guile-general is distributed in the hope that it will be useful,
;;;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;;;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;;; GNU General Public License for more details.
;;;; 
;;;; You should have received a copy of the GNU General Public License
;;;; along with octw-guile-general.  If not, see
;;;; <http://www.gnu.org/licenses/>.
;;;;
;;;; $Id: pregexp-extra.scm,v 1.1 2008-09-04 03:40:47 dean Exp $

(define-module (octw pregexp-extra))

(export extra-pregex-match-positions
	extra-match
	extra-replace)

(use-modules (ice-9 regex) (ice-9 pregexp))

(define (extra-pregex-match-positions pattern-fast pattern-full text)
  (and (string-match pattern-fast text)
       (pregexp-match-positions pattern-full text)))

(define (extra-match text position)
  (substring text (car position) (cdr position)))

(define (extra-replace text position replacement)
  (string-append (substring text 0 (car position))
		 replacement
		 (substring text (cdr position))))
